diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
new file mode 100644
index 7e85510..75844d5
*** a/src/include/access/heapam.h
--- b/src/include/access/heapam.h
*************** extern void ReleaseBulkInsertStatePin(Bu
*** 151,156 ****
--- 151,160 ----
  
  extern Oid heap_insert(Relation relation, HeapTuple tup, CommandId cid,
  			int options, BulkInsertState bistate);
+ extern bool heap_page_prepare_for_xid(Relation relation, Buffer buffer,
+ 									  TransactionId xid, bool multi);
+ extern bool rewrite_page_prepare_for_xid(Page page, TransactionId xid,
+ 										 bool multi);
  extern void heap_multi_insert(Relation relation, HeapTuple *tuples, int ntuples,
  				  CommandId cid, int options, BulkInsertState bistate);
  extern HTSU_Result heap_delete(Relation relation, ItemPointer tid,
*************** extern HTSU_Result heap_lock_tuple(Relat
*** 167,175 ****
  				bool follow_update,
  				Buffer *buffer, HeapUpdateFailureData *hufd);
  extern void heap_inplace_update(Relation relation, HeapTuple tuple);
! extern bool heap_freeze_tuple(HeapTupleHeader tuple, TransactionId cutoff_xid,
  				  TransactionId cutoff_multi);
! extern bool heap_tuple_needs_freeze(HeapTupleHeader tuple, TransactionId cutoff_xid,
  						MultiXactId cutoff_multi, Buffer buf);
  extern bool heap_tuple_needs_eventual_freeze(HeapTupleHeader tuple);
  
--- 171,179 ----
  				bool follow_update,
  				Buffer *buffer, HeapUpdateFailureData *hufd);
  extern void heap_inplace_update(Relation relation, HeapTuple tuple);
! extern bool heap_freeze_tuple(HeapTuple tuple, TransactionId cutoff_xid,
  				  TransactionId cutoff_multi);
! extern bool heap_tuple_needs_freeze(HeapTuple htup, TransactionId cutoff_xid,
  						MultiXactId cutoff_multi, Buffer buf);
  extern bool heap_tuple_needs_eventual_freeze(HeapTupleHeader tuple);
  
*************** extern void heap_update_snapshot(HeapSca
*** 185,195 ****
  extern void heap_page_prune_opt(Relation relation, Buffer buffer);
  extern int heap_page_prune(Relation relation, Buffer buffer,
  				TransactionId OldestXmin,
! 				bool report_stats, TransactionId *latestRemovedXid);
  extern void heap_page_prune_execute(Buffer buffer,
  						OffsetNumber *redirected, int nredirected,
  						OffsetNumber *nowdead, int ndead,
! 						OffsetNumber *nowunused, int nunused);
  extern void heap_get_root_tuples(Page page, OffsetNumber *root_offsets);
  
  /* in heap/syncscan.c */
--- 189,201 ----
  extern void heap_page_prune_opt(Relation relation, Buffer buffer);
  extern int heap_page_prune(Relation relation, Buffer buffer,
  				TransactionId OldestXmin,
! 				bool report_stats, TransactionId *latestRemovedXid,
! 				bool repairFragmentation);
  extern void heap_page_prune_execute(Buffer buffer,
  						OffsetNumber *redirected, int nredirected,
  						OffsetNumber *nowdead, int ndead,
! 						OffsetNumber *nowunused, int nunused,
! 						bool repairFragmentation);
  extern void heap_get_root_tuples(Page page, OffsetNumber *root_offsets);
  
  /* in heap/syncscan.c */
diff --git a/src/include/access/heapam_xlog.h b/src/include/access/heapam_xlog.h
new file mode 100644
index b285f17..31605ac
*** a/src/include/access/heapam_xlog.h
--- b/src/include/access/heapam_xlog.h
***************
*** 32,38 ****
  #define XLOG_HEAP_INSERT		0x00
  #define XLOG_HEAP_DELETE		0x10
  #define XLOG_HEAP_UPDATE		0x20
! /* 0x030 is free, was XLOG_HEAP_MOVE */
  #define XLOG_HEAP_HOT_UPDATE	0x40
  #define XLOG_HEAP_CONFIRM		0x50
  #define XLOG_HEAP_LOCK			0x60
--- 32,38 ----
  #define XLOG_HEAP_INSERT		0x00
  #define XLOG_HEAP_DELETE		0x10
  #define XLOG_HEAP_UPDATE		0x20
! #define XLOG_HEAP_BASE_SHIFT	0x30
  #define XLOG_HEAP_HOT_UPDATE	0x40
  #define XLOG_HEAP_CONFIRM		0x50
  #define XLOG_HEAP_LOCK			0x60
*************** typedef struct xl_heap_rewrite_mapping
*** 367,373 ****
  	XLogRecPtr	start_lsn;		/* Insert LSN at begin of rewrite */
  } xl_heap_rewrite_mapping;
  
! extern void HeapTupleHeaderAdvanceLatestRemovedXid(HeapTupleHeader tuple,
  									   TransactionId *latestRemovedXid);
  
  extern void heap_redo(XLogReaderState *record);
--- 367,383 ----
  	XLogRecPtr	start_lsn;		/* Insert LSN at begin of rewrite */
  } xl_heap_rewrite_mapping;
  
! /* shift the base of xids on heap page */
! typedef struct xl_heap_base_shift
! {
! 	int64		delta;			/* delta value to shift the base */
! 	bool		multi;			/* true to shift multixact base */
! } xl_heap_base_shift;
! 
! #define SizeOfHeapBaseShift (offsetof(xl_heap_base_shift, multi) + sizeof(bool))
! 
! 
! extern void HeapTupleHeaderAdvanceLatestRemovedXid(HeapTuple tuple,
  									   TransactionId *latestRemovedXid);
  
  extern void heap_redo(XLogReaderState *record);
*************** extern XLogRecPtr log_heap_clean(Relatio
*** 389,400 ****
  extern XLogRecPtr log_heap_freeze(Relation reln, Buffer buffer,
  				TransactionId cutoff_xid, xl_heap_freeze_tuple *tuples,
  				int ntuples);
! extern bool heap_prepare_freeze_tuple(HeapTupleHeader tuple,
  						  TransactionId cutoff_xid,
  						  TransactionId cutoff_multi,
  						  xl_heap_freeze_tuple *frz,
  						  bool *totally_frozen);
! extern void heap_execute_freeze_tuple(HeapTupleHeader tuple,
  						  xl_heap_freeze_tuple *xlrec_tp);
  extern XLogRecPtr log_heap_visible(RelFileNode rnode, Buffer heap_buffer,
  				 Buffer vm_buffer, TransactionId cutoff_xid, uint8 flags);
--- 399,412 ----
  extern XLogRecPtr log_heap_freeze(Relation reln, Buffer buffer,
  				TransactionId cutoff_xid, xl_heap_freeze_tuple *tuples,
  				int ntuples);
! extern bool heap_prepare_freeze_tuple(HeapTuple tuple,
  						  TransactionId cutoff_xid,
  						  TransactionId cutoff_multi,
  						  xl_heap_freeze_tuple *frz,
  						  bool *totally_frozen);
! extern void heap_execute_freeze_tuple(HeapTuple tuple,
! 						  xl_heap_freeze_tuple *xlrec_tp);
! extern void heap_execute_freeze_tuple_page(Page page, HeapTupleHeader tuple,
  						  xl_heap_freeze_tuple *xlrec_tp);
  extern XLogRecPtr log_heap_visible(RelFileNode rnode, Buffer heap_buffer,
  				 Buffer vm_buffer, TransactionId cutoff_xid, uint8 flags);
diff --git a/src/include/access/hio.h b/src/include/access/hio.h
new file mode 100644
index 2824f23..d9bf423
*** a/src/include/access/hio.h
--- b/src/include/access/hio.h
*************** typedef struct BulkInsertStateData
*** 36,42 ****
  
  
  extern void RelationPutHeapTuple(Relation relation, Buffer buffer,
! 					 HeapTuple tuple, bool token);
  extern Buffer RelationGetBufferForTuple(Relation relation, Size len,
  						  Buffer otherBuffer, int options,
  						  BulkInsertState bistate,
--- 36,42 ----
  
  
  extern void RelationPutHeapTuple(Relation relation, Buffer buffer,
! 					 HeapTuple tuple, bool token, TransactionId xid);
  extern Buffer RelationGetBufferForTuple(Relation relation, Size len,
  						  Buffer otherBuffer, int options,
  						  BulkInsertState bistate,
diff --git a/src/include/access/htup.h b/src/include/access/htup.h
new file mode 100644
index 870adf4..cd39213
*** a/src/include/access/htup.h
--- b/src/include/access/htup.h
*************** typedef MinimalTupleData *MinimalTuple;
*** 62,69 ****
  typedef struct HeapTupleData
  {
  	uint32		t_len;			/* length of *t_data */
- 	ItemPointerData t_self;		/* SelfItemPointer */
  	Oid			t_tableOid;		/* table the tuple came from */
  	HeapTupleHeader t_data;		/* -> tuple header and data */
  } HeapTupleData;
  
--- 62,71 ----
  typedef struct HeapTupleData
  {
  	uint32		t_len;			/* length of *t_data */
  	Oid			t_tableOid;		/* table the tuple came from */
+ 	TransactionId	t_xid_base;
+ 	TransactionId	t_multi_base;
+ 	ItemPointerData t_self;		/* SelfItemPointer */
  	HeapTupleHeader t_data;		/* -> tuple header and data */
  } HeapTupleData;
  
*************** typedef HeapTupleData *HeapTuple;
*** 79,88 ****
  /* HeapTupleHeader functions implemented in utils/time/combocid.c */
  extern CommandId HeapTupleHeaderGetCmin(HeapTupleHeader tup);
  extern CommandId HeapTupleHeaderGetCmax(HeapTupleHeader tup);
! extern void HeapTupleHeaderAdjustCmax(HeapTupleHeader tup,
  						  CommandId *cmax, bool *iscombo);
  
  /* Prototype for HeapTupleHeader accessors in heapam.c */
! extern TransactionId HeapTupleGetUpdateXid(HeapTupleHeader tuple);
  
  #endif   /* HTUP_H */
--- 81,90 ----
  /* HeapTupleHeader functions implemented in utils/time/combocid.c */
  extern CommandId HeapTupleHeaderGetCmin(HeapTupleHeader tup);
  extern CommandId HeapTupleHeaderGetCmax(HeapTupleHeader tup);
! extern void HeapTupleHeaderAdjustCmax(HeapTuple tup,
  						  CommandId *cmax, bool *iscombo);
  
  /* Prototype for HeapTupleHeader accessors in heapam.c */
! extern TransactionId HeapTupleGetUpdateXid(HeapTuple tuple);
  
  #endif   /* HTUP_H */
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
new file mode 100644
index e365f4f..22f8206
*** a/src/include/access/htup_details.h
--- b/src/include/access/htup_details.h
***************
*** 115,127 ****
  
  typedef struct HeapTupleFields
  {
! 	TransactionId t_xmin;		/* inserting xact ID */
! 	TransactionId t_xmax;		/* deleting or locking xact ID */
  
  	union
  	{
  		CommandId	t_cid;		/* inserting or deleting command ID, or both */
! 		TransactionId t_xvac;	/* old-style VACUUM FULL xact ID */
  	}			t_field3;
  } HeapTupleFields;
  
--- 115,127 ----
  
  typedef struct HeapTupleFields
  {
! 	ShortTransactionId t_xmin;		/* inserting xact ID */
! 	ShortTransactionId t_xmax;		/* deleting or locking xact ID */
  
  	union
  	{
  		CommandId	t_cid;		/* inserting or deleting command ID, or both */
! 		ShortTransactionId t_xvac;	/* old-style VACUUM FULL xact ID */
  	}			t_field3;
  } HeapTupleFields;
  
*************** struct HeapTupleHeaderData
*** 291,296 ****
--- 291,314 ----
   * macros evaluate their other argument only once.
   */
  
+ #define HeapTupleCopyBaseFromPage(tup, page) \
+ { \
+ 	(tup)->t_xid_base = HeapPageGetSpecial(page)->pd_xid_base; \
+ 	(tup)->t_multi_base = HeapPageGetSpecial(page)->pd_multi_base; \
+ }
+ 
+ #define HeapTupleCopyBase(dest, src) \
+ { \
+ 	(dest)->t_xid_base = (src)->t_xid_base; \
+ 	(dest)->t_multi_base = (src)->t_xid_base; \
+ }
+ 
+ #define HeapTupleSetZeroBase(tup) \
+ { \
+ 	(tup)->t_xid_base = InvalidTransactionId; \
+ 	(tup)->t_multi_base = InvalidTransactionId; \
+ }
+ 
  /*
   * HeapTupleHeaderGetRawXmin returns the "raw" xmin field, which is the xid
   * originally used to insert the tuple.  However, the tuple might actually
*************** struct HeapTupleHeaderData
*** 299,318 ****
   * the xmin to FrozenTransactionId, and that value may still be encountered
   * on disk.
   */
! #define HeapTupleHeaderGetRawXmin(tup) \
  ( \
! 	(tup)->t_choice.t_heap.t_xmin \
  )
  
! #define HeapTupleHeaderGetXmin(tup) \
  ( \
! 	HeapTupleHeaderXminFrozen(tup) ? \
! 		FrozenTransactionId : HeapTupleHeaderGetRawXmin(tup) \
  )
  
! #define HeapTupleHeaderSetXmin(tup, xid) \
  ( \
! 	(tup)->t_choice.t_heap.t_xmin = (xid) \
  )
  
  #define HeapTupleHeaderXminCommitted(tup) \
--- 317,341 ----
   * the xmin to FrozenTransactionId, and that value may still be encountered
   * on disk.
   */
! #define HeapTupleGetRawXmin(tup) \
  ( \
! 	ShortTransactionIdToNormal((tup)->t_xid_base, (tup)->t_data->t_choice.t_heap.t_xmin) \
  )
  
! #define HeapTupleGetXmin(tup) \
  ( \
! 	HeapTupleHeaderXminFrozen((tup)->t_data) ? \
! 		FrozenTransactionId : HeapTupleGetRawXmin(tup) \
  )
  
! #define HeapTupleSetXmin(tup, xid) \
  ( \
! 	(tup)->t_data->t_choice.t_heap.t_xmin = NormalTransactionIdToShort((tup)->t_xid_base, (xid)) \
! )
! 
! #define HeapTupleHeaderSetXmin(page, tup, xid) \
! ( \
! 	(tup)->t_choice.t_heap.t_xmin = NormalTransactionIdToShort(HeapPageGetSpecial(page)->pd_xid_base, (xid)) \
  )
  
  #define HeapTupleHeaderXminCommitted(tup) \
*************** struct HeapTupleHeaderData
*** 356,379 ****
   * to resolve the MultiXactId if necessary.  This might involve multixact I/O,
   * so it should only be used if absolutely necessary.
   */
! #define HeapTupleHeaderGetUpdateXid(tup) \
  ( \
! 	(!((tup)->t_infomask & HEAP_XMAX_INVALID) && \
! 	 ((tup)->t_infomask & HEAP_XMAX_IS_MULTI) && \
! 	 !((tup)->t_infomask & HEAP_XMAX_LOCK_ONLY)) ? \
  		HeapTupleGetUpdateXid(tup) \
  	: \
! 		HeapTupleHeaderGetRawXmax(tup) \
  )
  
! #define HeapTupleHeaderGetRawXmax(tup) \
  ( \
! 	(tup)->t_choice.t_heap.t_xmax \
  )
  
! #define HeapTupleHeaderSetXmax(tup, xid) \
  ( \
! 	(tup)->t_choice.t_heap.t_xmax = (xid) \
  )
  
  /*
--- 379,422 ----
   * to resolve the MultiXactId if necessary.  This might involve multixact I/O,
   * so it should only be used if absolutely necessary.
   */
! #define HeapTupleGetUpdateXidAny(tup) \
  ( \
! 	(!((tup)->t_data->t_infomask & HEAP_XMAX_INVALID) && \
! 	 ((tup)->t_data->t_infomask & HEAP_XMAX_IS_MULTI) && \
! 	 !((tup)->t_data->t_infomask & HEAP_XMAX_LOCK_ONLY)) ? \
  		HeapTupleGetUpdateXid(tup) \
  	: \
! 		HeapTupleGetRawXmax(tup) \
  )
  
! #define HeapTupleGetRawXmax(tup) \
  ( \
! 	ShortTransactionIdToNormal( \
! 		((tup)->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? (tup)->t_multi_base : (tup)->t_xid_base, \
! 		(tup)->t_data->t_choice.t_heap.t_xmax) \
  )
  
! #define HeapTupleHeaderGetRawXmax(page, tup) \
  ( \
! 	ShortTransactionIdToNormal( \
! 		((tup)->t_infomask & HEAP_XMAX_IS_MULTI) ? HeapPageGetSpecial(page)->pd_multi_base : HeapPageGetSpecial(page)->pd_xid_base, \
! 		(tup)->t_choice.t_heap.t_xmax) \
! )
! 
! #define HeapTupleSetXmax(tup, xid) \
! ( \
! 	(tup)->t_data->t_choice.t_heap.t_xmax = \
! 		NormalTransactionIdToShort( \
! 			((tup)->t_data->t_infomask & HEAP_XMAX_IS_MULTI) ? (tup)->t_multi_base : (tup)->t_xid_base, \
! 			(xid)) \
! )
! 
! #define HeapTupleHeaderSetXmax(page, tup, xid) \
! ( \
! 	(tup)->t_choice.t_heap.t_xmax = \
! 		NormalTransactionIdToShort( \
! 			((tup)->t_infomask & HEAP_XMAX_IS_MULTI) ? HeapPageGetSpecial(page)->pd_multi_base : HeapPageGetSpecial(page)->pd_xid_base, \
! 			(xid)) \
  )
  
  /*
diff --git a/src/include/access/multixact.h b/src/include/access/multixact.h
new file mode 100644
index 85997a4..eb4905a
*** a/src/include/access/multixact.h
--- b/src/include/access/multixact.h
***************
*** 17,32 ****
  
  /*
   * The first two MultiXactId values are reserved to store the truncation Xid
!  * and epoch of the first segment, so we start assigning multixact values from
   * 2.
   */
! #define InvalidMultiXactId	((MultiXactId) 0)
! #define FirstMultiXactId	((MultiXactId) 1)
! #define MaxMultiXactId		((MultiXactId) 0xFFFFFFFF)
  
  #define MultiXactIdIsValid(multi) ((multi) != InvalidMultiXactId)
  
! #define MaxMultiXactOffset	((MultiXactOffset) 0xFFFFFFFF)
  
  /* Number of SLRU buffers to use for multixact */
  #define NUM_MXACTOFFSET_BUFFERS		8
--- 17,32 ----
  
  /*
   * The first two MultiXactId values are reserved to store the truncation Xid
!  * and base of the first segment, so we start assigning multixact values from
   * 2.
   */
! #define InvalidMultiXactId	UINT64CONST(0)
! #define FirstMultiXactId	UINT64CONST(1)
! #define MaxMultiXactId		UINT64CONST(0xFFFFFFFFFFFFFFFF)
  
  #define MultiXactIdIsValid(multi) ((multi) != InvalidMultiXactId)
  
! #define MaxMultiXactOffset	UINT64CONST(0xFFFFFFFFFFFFFFFF)
  
  /* Number of SLRU buffers to use for multixact */
  #define NUM_MXACTOFFSET_BUFFERS		8
*************** extern bool MultiXactIdIsRunning(MultiXa
*** 112,120 ****
  extern void MultiXactIdSetOldestMember(void);
  extern int GetMultiXactIdMembers(MultiXactId multi, MultiXactMember **xids,
  					  bool allow_old, bool isLockOnly);
- extern bool MultiXactIdPrecedes(MultiXactId multi1, MultiXactId multi2);
- extern bool MultiXactIdPrecedesOrEquals(MultiXactId multi1,
- 							MultiXactId multi2);
  
  extern void AtEOXact_MultiXact(void);
  extern void AtPrepare_MultiXact(void);
--- 112,117 ----
*************** extern void MultiXactSetNextMXact(MultiX
*** 142,148 ****
  extern void MultiXactAdvanceNextMXact(MultiXactId minMulti,
  						  MultiXactOffset minMultiOffset);
  extern void MultiXactAdvanceOldest(MultiXactId oldestMulti, Oid oldestMultiDB);
- extern int	MultiXactMemberFreezeThreshold(void);
  
  extern void multixact_twophase_recover(TransactionId xid, uint16 info,
  						   void *recdata, uint32 len);
--- 139,144 ----
diff --git a/src/include/access/rewriteheap.h b/src/include/access/rewriteheap.h
new file mode 100644
index 564c2ad..c2fa6dd
*** a/src/include/access/rewriteheap.h
--- b/src/include/access/rewriteheap.h
*************** typedef struct LogicalRewriteMappingData
*** 51,57 ****
   * 6) xid of the xact performing the mapping
   * ---
   */
! #define LOGICAL_REWRITE_FORMAT "map-%x-%x-%X_%X-%x-%x"
  void		CheckPointLogicalRewriteHeap(void);
  
  #endif   /* REWRITE_HEAP_H */
--- 51,57 ----
   * 6) xid of the xact performing the mapping
   * ---
   */
! #define LOGICAL_REWRITE_FORMAT "map-%x-%x-%X_%X-%x_%x-%x_%x"
  void		CheckPointLogicalRewriteHeap(void);
  
  #endif   /* REWRITE_HEAP_H */
diff --git a/src/include/access/slru.h b/src/include/access/slru.h
new file mode 100644
index 722867d..8b0c8cd
*** a/src/include/access/slru.h
--- b/src/include/access/slru.h
***************
*** 34,43 ****
   * digits.  This sets a lower bound on the segment size (64K transactions
   * for 32-bit TransactionIds).
   */
! #define SLRU_PAGES_PER_SEGMENT	32
  
  /* Maximum length of an SLRU name */
! #define SLRU_MAX_NAME_LENGTH	32
  
  /*
   * Page status codes.  Note that these do not include the "dirty" bit.
--- 34,43 ----
   * digits.  This sets a lower bound on the segment size (64K transactions
   * for 32-bit TransactionIds).
   */
! #define SLRU_PAGES_PER_SEGMENT	2048
  
  /* Maximum length of an SLRU name */
! #define SLRU_MAX_NAME_LENGTH	64
  
  /*
   * Page status codes.  Note that these do not include the "dirty" bit.
*************** typedef struct SlruSharedData
*** 70,76 ****
  	char	  **page_buffer;
  	SlruPageStatus *page_status;
  	bool	   *page_dirty;
! 	int		   *page_number;
  	int		   *page_lru_count;
  
  	/*
--- 70,76 ----
  	char	  **page_buffer;
  	SlruPageStatus *page_status;
  	bool	   *page_dirty;
! 	int64	   *page_number;
  	int		   *page_lru_count;
  
  	/*
*************** typedef struct SlruSharedData
*** 100,106 ****
  	 * this is not critical data, since we use it only to avoid swapping out
  	 * the latest page.
  	 */
! 	int			latest_page_number;
  
  	/* LWLocks */
  	int			lwlock_tranche_id;
--- 100,106 ----
  	 * this is not critical data, since we use it only to avoid swapping out
  	 * the latest page.
  	 */
! 	int64		latest_page_number;
  
  	/* LWLocks */
  	int			lwlock_tranche_id;
*************** typedef struct SlruCtlData
*** 125,137 ****
  	bool		do_fsync;
  
  	/*
- 	 * Decide which of two page numbers is "older" for truncation purposes. We
- 	 * need to use comparison of TransactionIds here in order to do the right
- 	 * thing with wraparound XID arithmetic.
- 	 */
- 	bool		(*PagePrecedes) (int, int);
- 
- 	/*
  	 * Dir is set during SimpleLruInit and does not change thereafter. Since
  	 * it's always the same, it doesn't need to be in shared memory.
  	 */
--- 125,130 ----
*************** typedef SlruCtlData *SlruCtl;
*** 144,168 ****
  extern Size SimpleLruShmemSize(int nslots, int nlsns);
  extern void SimpleLruInit(SlruCtl ctl, const char *name, int nslots, int nlsns,
  			  LWLock *ctllock, const char *subdir, int tranche_id);
! extern int	SimpleLruZeroPage(SlruCtl ctl, int pageno);
! extern int SimpleLruReadPage(SlruCtl ctl, int pageno, bool write_ok,
  				  TransactionId xid);
! extern int SimpleLruReadPage_ReadOnly(SlruCtl ctl, int pageno,
  						   TransactionId xid);
  extern void SimpleLruWritePage(SlruCtl ctl, int slotno);
  extern void SimpleLruFlush(SlruCtl ctl, bool allow_redirtied);
! extern void SimpleLruTruncate(SlruCtl ctl, int cutoffPage);
! extern bool SimpleLruDoesPhysicalPageExist(SlruCtl ctl, int pageno);
  
! typedef bool (*SlruScanCallback) (SlruCtl ctl, char *filename, int segpage,
  											  void *data);
  extern bool SlruScanDirectory(SlruCtl ctl, SlruScanCallback callback, void *data);
! extern void SlruDeleteSegment(SlruCtl ctl, int segno);
  
  /* SlruScanDirectory public callbacks */
  extern bool SlruScanDirCbReportPresence(SlruCtl ctl, char *filename,
! 							int segpage, void *data);
! extern bool SlruScanDirCbDeleteAll(SlruCtl ctl, char *filename, int segpage,
  					   void *data);
  
  #endif   /* SLRU_H */
--- 137,161 ----
  extern Size SimpleLruShmemSize(int nslots, int nlsns);
  extern void SimpleLruInit(SlruCtl ctl, const char *name, int nslots, int nlsns,
  			  LWLock *ctllock, const char *subdir, int tranche_id);
! extern int	SimpleLruZeroPage(SlruCtl ctl, int64 pageno);
! extern int SimpleLruReadPage(SlruCtl ctl, int64 pageno, bool write_ok,
  				  TransactionId xid);
! extern int SimpleLruReadPage_ReadOnly(SlruCtl ctl, int64 pageno,
  						   TransactionId xid);
  extern void SimpleLruWritePage(SlruCtl ctl, int slotno);
  extern void SimpleLruFlush(SlruCtl ctl, bool allow_redirtied);
! extern void SimpleLruTruncate(SlruCtl ctl, int64 cutoffPage);
! extern bool SimpleLruDoesPhysicalPageExist(SlruCtl ctl, int64 pageno);
  
! typedef bool (*SlruScanCallback) (SlruCtl ctl, char *filename, int64 segpage,
  											  void *data);
  extern bool SlruScanDirectory(SlruCtl ctl, SlruScanCallback callback, void *data);
! extern void SlruDeleteSegment(SlruCtl ctl, int64 segno);
  
  /* SlruScanDirectory public callbacks */
  extern bool SlruScanDirCbReportPresence(SlruCtl ctl, char *filename,
! 							int64 segpage, void *data);
! extern bool SlruScanDirCbDeleteAll(SlruCtl ctl, char *filename, int64 segpage,
  					   void *data);
  
  #endif   /* SLRU_H */
diff --git a/src/include/access/transam.h b/src/include/access/transam.h
new file mode 100644
index d25a2dd..5dbf6b2
*** a/src/include/access/transam.h
--- b/src/include/access/transam.h
***************
*** 28,38 ****
   * Note: if you need to change it, you must change pg_class.h as well.
   * ----------------
   */
! #define InvalidTransactionId		((TransactionId) 0)
! #define BootstrapTransactionId		((TransactionId) 1)
! #define FrozenTransactionId			((TransactionId) 2)
! #define FirstNormalTransactionId	((TransactionId) 3)
! #define MaxTransactionId			((TransactionId) 0xFFFFFFFF)
  
  /* ----------------
   *		transaction ID manipulation macros
--- 28,39 ----
   * Note: if you need to change it, you must change pg_class.h as well.
   * ----------------
   */
! #define InvalidTransactionId		UINT64CONST(0)
! #define BootstrapTransactionId		UINT64CONST(1)
! #define FrozenTransactionId			UINT64CONST(2)
! #define FirstNormalTransactionId	UINT64CONST(3)
! #define MaxTransactionId			UINT64CONST(0xFFFFFFFFFFFFFFFF)
! #define MaxShortTransactionId		((TransactionId) 0x7FFFFFFF)
  
  /* ----------------
   *		transaction ID manipulation macros
***************
*** 43,72 ****
  #define TransactionIdEquals(id1, id2)	((id1) == (id2))
  #define TransactionIdStore(xid, dest)	(*(dest) = (xid))
  #define StoreInvalidTransactionId(dest) (*(dest) = InvalidTransactionId)
  
  /* advance a transaction ID variable, handling wraparound correctly */
  #define TransactionIdAdvance(dest)	\
  	do { \
  		(dest)++; \
! 		if ((dest) < FirstNormalTransactionId) \
! 			(dest) = FirstNormalTransactionId; \
  	} while(0)
  
  /* back up a transaction ID variable, handling wraparound correctly */
  #define TransactionIdRetreat(dest)	\
  	do { \
  		(dest)--; \
! 	} while ((dest) < FirstNormalTransactionId)
  
  /* compare two XIDs already known to be normal; this is a macro for speed */
  #define NormalTransactionIdPrecedes(id1, id2) \
  	(AssertMacro(TransactionIdIsNormal(id1) && TransactionIdIsNormal(id2)), \
! 	(int32) ((id1) - (id2)) < 0)
  
  /* compare two XIDs already known to be normal; this is a macro for speed */
  #define NormalTransactionIdFollows(id1, id2) \
  	(AssertMacro(TransactionIdIsNormal(id1) && TransactionIdIsNormal(id2)), \
! 	(int32) ((id1) - (id2)) > 0)
  
  /* ----------
   *		Object ID (OID) zero is InvalidOid.
--- 44,80 ----
  #define TransactionIdEquals(id1, id2)	((id1) == (id2))
  #define TransactionIdStore(xid, dest)	(*(dest) = (xid))
  #define StoreInvalidTransactionId(dest) (*(dest) = InvalidTransactionId)
+ #define ShortTransactionIdToNormal(base, xid) \
+ 	(TransactionIdIsNormal(xid) ? (TransactionId)(xid) + (base) : (TransactionId)(xid))
+ #define NormalTransactionIdToShort(base, xid) \
+ 	(TransactionIdIsNormal(xid) ? (ShortTransactionId)( \
+ 		AssertMacro((xid) >= (base) + FirstNormalTransactionId), \
+ 		AssertMacro((xid) <= (base) + MaxShortTransactionId), \
+ 		(xid) - (base)) : (ShortTransactionId)(xid))
  
  /* advance a transaction ID variable, handling wraparound correctly */
  #define TransactionIdAdvance(dest)	\
  	do { \
  		(dest)++; \
! 		Assert((dest) > FirstNormalTransactionId); \
  	} while(0)
  
  /* back up a transaction ID variable, handling wraparound correctly */
  #define TransactionIdRetreat(dest)	\
  	do { \
+ 		Assert((dest) > FirstNormalTransactionId); \
  		(dest)--; \
! 	} while(0)
  
  /* compare two XIDs already known to be normal; this is a macro for speed */
  #define NormalTransactionIdPrecedes(id1, id2) \
  	(AssertMacro(TransactionIdIsNormal(id1) && TransactionIdIsNormal(id2)), \
! 	(int64) ((id1) - (id2)) < 0)
  
  /* compare two XIDs already known to be normal; this is a macro for speed */
  #define NormalTransactionIdFollows(id1, id2) \
  	(AssertMacro(TransactionIdIsNormal(id1) && TransactionIdIsNormal(id2)), \
! 	(int64) ((id1) - (id2)) > 0)
  
  /* ----------
   *		Object ID (OID) zero is InvalidOid.
*************** typedef struct VariableCacheData
*** 118,126 ****
  
  	TransactionId oldestXid;	/* cluster-wide minimum datfrozenxid */
  	TransactionId xidVacLimit;	/* start forcing autovacuums here */
- 	TransactionId xidWarnLimit; /* start complaining here */
- 	TransactionId xidStopLimit; /* refuse to advance nextXid beyond here */
- 	TransactionId xidWrapLimit; /* where the world ends */
  	Oid			oldestXidDB;	/* database with minimum datfrozenxid */
  
  	/*
--- 126,131 ----
*************** extern void TransactionIdAbort(Transacti
*** 166,175 ****
  extern void TransactionIdCommitTree(TransactionId xid, int nxids, TransactionId *xids);
  extern void TransactionIdAsyncCommitTree(TransactionId xid, int nxids, TransactionId *xids, XLogRecPtr lsn);
  extern void TransactionIdAbortTree(TransactionId xid, int nxids, TransactionId *xids);
- extern bool TransactionIdPrecedes(TransactionId id1, TransactionId id2);
- extern bool TransactionIdPrecedesOrEquals(TransactionId id1, TransactionId id2);
- extern bool TransactionIdFollows(TransactionId id1, TransactionId id2);
- extern bool TransactionIdFollowsOrEquals(TransactionId id1, TransactionId id2);
  extern TransactionId TransactionIdLatest(TransactionId mainxid,
  					int nxids, const TransactionId *xids);
  extern XLogRecPtr TransactionIdGetCommitLSN(TransactionId xid);
--- 171,176 ----
diff --git a/src/include/access/xact.h b/src/include/access/xact.h
new file mode 100644
index 7eb85b7..2b2640b
*** a/src/include/access/xact.h
--- b/src/include/access/xact.h
*************** typedef void (*SubXactCallback) (SubXact
*** 152,160 ****
   */
  #define XACT_XINFO_HAS_DBINFO			(1U << 0)
  #define XACT_XINFO_HAS_SUBXACTS			(1U << 1)
! #define XACT_XINFO_HAS_RELFILENODES		(1U << 2)
! #define XACT_XINFO_HAS_INVALS			(1U << 3)
! #define XACT_XINFO_HAS_TWOPHASE			(1U << 4)
  #define XACT_XINFO_HAS_ORIGIN			(1U << 5)
  #define XACT_XINFO_HAS_AE_LOCKS			(1U << 6)
  
--- 152,160 ----
   */
  #define XACT_XINFO_HAS_DBINFO			(1U << 0)
  #define XACT_XINFO_HAS_SUBXACTS			(1U << 1)
! #define XACT_XINFO_HAS_TWOPHASE			(1U << 2)
! #define XACT_XINFO_HAS_RELFILENODES		(1U << 3)
! #define XACT_XINFO_HAS_INVALS			(1U << 4)
  #define XACT_XINFO_HAS_ORIGIN			(1U << 5)
  #define XACT_XINFO_HAS_AE_LOCKS			(1U << 6)
  
*************** typedef struct xl_xact_xinfo
*** 211,217 ****
  	 * four so following records don't have to care about alignment. Commit
  	 * records can be large, so copying large portions isn't attractive.
  	 */
! 	uint32		xinfo;
  } xl_xact_xinfo;
  
  typedef struct xl_xact_dbinfo
--- 211,217 ----
  	 * four so following records don't have to care about alignment. Commit
  	 * records can be large, so copying large portions isn't attractive.
  	 */
! 	uint64		xinfo;
  } xl_xact_xinfo;
  
  typedef struct xl_xact_dbinfo
*************** typedef struct xl_xact_subxacts
*** 227,232 ****
--- 227,237 ----
  } xl_xact_subxacts;
  #define MinSizeOfXactSubxacts offsetof(xl_xact_subxacts, subxacts)
  
+ typedef struct xl_xact_twophase
+ {
+ 	TransactionId xid;
+ } xl_xact_twophase;
+ 
  typedef struct xl_xact_relfilenodes
  {
  	int			nrels;			/* number of subtransaction XIDs */
*************** typedef struct xl_xact_invals
*** 241,251 ****
  } xl_xact_invals;
  #define MinSizeOfXactInvals offsetof(xl_xact_invals, msgs)
  
- typedef struct xl_xact_twophase
- {
- 	TransactionId xid;
- } xl_xact_twophase;
- 
  typedef struct xl_xact_origin
  {
  	XLogRecPtr	origin_lsn;
--- 246,251 ----
*************** typedef struct xl_xact_commit
*** 259,267 ****
  	/* xl_xact_xinfo follows if XLOG_XACT_HAS_INFO */
  	/* xl_xact_dbinfo follows if XINFO_HAS_DBINFO */
  	/* xl_xact_subxacts follows if XINFO_HAS_SUBXACT */
  	/* xl_xact_relfilenodes follows if XINFO_HAS_RELFILENODES */
  	/* xl_xact_invals follows if XINFO_HAS_INVALS */
- 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
  	/* xl_xact_origin follows if XINFO_HAS_ORIGIN, stored unaligned! */
  } xl_xact_commit;
  #define MinSizeOfXactCommit (offsetof(xl_xact_commit, xact_time) + sizeof(TimestampTz))
--- 259,267 ----
  	/* xl_xact_xinfo follows if XLOG_XACT_HAS_INFO */
  	/* xl_xact_dbinfo follows if XINFO_HAS_DBINFO */
  	/* xl_xact_subxacts follows if XINFO_HAS_SUBXACT */
+ 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
  	/* xl_xact_relfilenodes follows if XINFO_HAS_RELFILENODES */
  	/* xl_xact_invals follows if XINFO_HAS_INVALS */
  	/* xl_xact_origin follows if XINFO_HAS_ORIGIN, stored unaligned! */
  } xl_xact_commit;
  #define MinSizeOfXactCommit (offsetof(xl_xact_commit, xact_time) + sizeof(TimestampTz))
*************** typedef struct xl_xact_abort
*** 273,281 ****
  	/* xl_xact_xinfo follows if XLOG_XACT_HAS_INFO */
  	/* No db_info required */
  	/* xl_xact_subxacts follows if HAS_SUBXACT */
  	/* xl_xact_relfilenodes follows if HAS_RELFILENODES */
  	/* No invalidation messages needed. */
- 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
  } xl_xact_abort;
  #define MinSizeOfXactAbort sizeof(xl_xact_abort)
  
--- 273,281 ----
  	/* xl_xact_xinfo follows if XLOG_XACT_HAS_INFO */
  	/* No db_info required */
  	/* xl_xact_subxacts follows if HAS_SUBXACT */
+ 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
  	/* xl_xact_relfilenodes follows if HAS_RELFILENODES */
  	/* No invalidation messages needed. */
  } xl_xact_abort;
  #define MinSizeOfXactAbort sizeof(xl_xact_abort)
  
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
new file mode 100644
index e00ab12..41c2fde
*** a/src/include/access/xlog.h
--- b/src/include/access/xlog.h
*************** extern XLogRecPtr GetRedoRecPtr(void);
*** 275,281 ****
  extern XLogRecPtr GetInsertRecPtr(void);
  extern XLogRecPtr GetFlushRecPtr(void);
  extern XLogRecPtr GetLastImportantRecPtr(void);
- extern void GetNextXidAndEpoch(TransactionId *xid, uint32 *epoch);
  extern void RemovePromoteSignalFiles(void);
  
  extern bool CheckPromoteSignal(void);
--- 275,280 ----
